//
//  CarouselTemplatePresenter.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/18/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import Foundation
import RxSwift
import RxCocoa
import Action

enum SuperSpaManagementError: Error {
    case internalError
    init(error: Error) {
        self = .internalError
    }
}

protocol CarouselTemplateWireframeInterface: WireframeInterface {

}

protocol CaroulseTemplateListener {
    func carouselTemplateDidGetErorr(_ error: SuperSpaManagementError)
    func carouselTemplateDidGetEmptyData()
    func carouselTemplateDidSelected(_ model: CarouselItemable)
    func carouselTemplateGotData()
}

protocol CarouselTemplateViewInterface: ViewInterface {
    var viewModels: BehaviorRelay<[ProductCarouselCellViewModel]> { get }
}

final class CarouselTemplatePresenter: CarouselTemplatePresenterInterface {

    // MARK: - Private properties -

    private lazy var getProductsAction = makeGetProductsAction()
    private let disposeBag = DisposeBag()
    
    private unowned let view: CarouselTemplateViewInterface
    private let interactor: CarouselTemplateInteractorInterface
    private let wireframe: CarouselTemplateWireframeInterface
    private let style: CarouselTemplateStyle

    // MARK: - Lifecycle -

    init(view: CarouselTemplateViewInterface,
         interactor: CarouselTemplateInteractorInterface,
         wireframe: CarouselTemplateWireframeInterface,
         style: CarouselTemplateStyle ) {
        
        self.view = view
        self.interactor = interactor
        self.wireframe = wireframe
        self.style = style
        
        configurePresenter()
    }
}

// MARK: - Extensions -

extension CarouselTemplatePresenter {
    private func configurePresenter() {
        getProductsAction
            .elements
            .filterEmpty()
            .map { [weak self] products -> [Product] in
                guard let self = self else { return products }
                switch self.style {
                case.medium, .large:
                    return products
                case .largeSingle:
                    return products.prefix(1).map { $0 }
                }
            }
            .map {
                $0.map { _ in ProductCarouselCellViewModel() }
            }
            .bind(to: view.viewModels)
            .disposed(by: disposeBag)
        
        getProductsAction.execute(.zero)
    }
}

extension CarouselTemplatePresenter {
    func makeGetProductsAction() -> Action<Int, [Product]> {
        return Action<Int, [Product]> { [unowned  self] categoryId in
            return interactor.getProducts(by: categoryId)
        }
    }
}
